# READMEDY

## General Information

README - An opinionated interactive readme generator

## Dependencies

Any external dependencies (things that couldn't be installed just using the
GEMFILE) should go here. If there is a single resource to access them, or if
they are not one of our standard tools, a link to the project should be
included.

* Ruby version

* Rails version

* Database type and version (e.g. PostgreSQL 9.3.5)

* External dependencies such as Redis/ElasticSearch.

## Setup

We are transitioning to using ./setup/go.sh to automate this process. If your
project uses that, then reference it here. This section should also cover the
.env file expectations as well as the setup for any of the external dependencies
listed above (endpoint naming requirements, database table requirements etc.)

If there are specific requirements around seed data, or database image
acquisition for the development cycle it should go here as well.

## Development

Overview of the development cycle, from picking up a ticket through to closing
it. Likely the same across all of our projects, but can be edited as necessary.

Should also cover style (although perhaps a style-guide is a separate resource),
outlining a RuboCOP setup, or hound or something similar.

* Choose a ticket from the Jira sprint board/Create a new Jira ticket/Pick from
  the backlog.

* Create a feature branch off the develop branch.

  * Feature branch naming convnention: feature/JIRATICKETID-SUMMARY, e.g.
    feature/NEP-274-Adding-a-field

* If the ticket is sufficiently complex, write a design PR and submit it to the
  project.

* Once there is a consensus on how to approach the ticket, begin.

## Testing

Overview of testing practices in the project. Again, these are likely common
across all our projects, but some legacy applications may have some caveats that
onboarded devs need to be aware of.

* Testing framework - RSpec / MiniTest / Test::Unit

* Capybara / Cucumber

* Javascript testing

* Are we using feature tests or focusing on unit tests

* Testing requirements for a ticket to be accepted (coverage/functionality)

## Common Problems / Bugs

Any identified issues that are either not large enough to warrant a Jira ticket
(i.e development concerns that don't exist in production) or are showstoppers
that a new dev would need to be aware of and work around should go here.

## Staging/Edge Access and Production location

A list of the staging and edge endpoints, as well as intstructions to get access
to those systems.

The production endpoint.

Basically just the words - 'Go ask Paul nicely'.

## Notes

Addendums on style, review notes, and any other information that could be
useful.
